File exists, but cannot be opened.How to check- whether it could be opened to read when it exists


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting File exists, but cannot be opened.How to check- whether it could be opened to read when it exists
# 1  
Old 05-10-2012
File exists, but cannot be opened.How to check- whether it could be opened to read when it exists

Hi

Code:
#Testing for  file existence 
if [ -f $DIR/SCHOOL_FAC.txt ]; then   
  echo 'SCHOOL data is available for processing'   
else   
  echo 'SCHOOL DATA IS NOT AVAILABLE FOR PROCESSING'  
  :

i wrote a script, where it begins by checking if file exists or not.
If it exists, it truncates the database table and bcp's new data from file into the table.

Now, I had a situtation, where the file exists, but couldnot open,
and since my above statements checks for file existence, the database table is truncated and the table became empty.
When tried to bcp the file...the file couldnot be opened and it failed.

Now the database table lost its old data and since file couldnot be opened, the bcp couldnot load data into the table.

How can i check whether file is readable,so that i can take of truncating the table only when the file is readable and can be opened.

Any answer is appreciated, with respect to my above problem.

Thank You.Smilie
# 2  
Old 05-10-2012
There's probably better ways in more advanced shells than a basic bourne, but:

Code:
if ! cat filename > /dev/null
then
        echo "filename can't be read'
        exit 1
fi

This User Gave Thanks to Corona688 For This Post:
# 3  
Old 05-10-2012
[ should include -r for readable and -w for writable.
This User Gave Thanks to neutronscott For This Post:
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. UNIX for Beginners Questions & Answers

Check if file exists

I need to check whether a file exists and has been changed. The file should contain a specific string. The file should also have been changed within the last ten seconds. How do I do that? (3 Replies)
Discussion started by: locoroco
3 Replies

2. Shell Programming and Scripting

To check if file exists

Hi, I have the below code written. However I am not getting the desired output I am checking if the particular path has file in it. #!/bin/bash ls -l /IRS2/IRS2_ODI/INFILE/*LS* 1>/dev/null 2>/dev/null if then echo $? echo "File Exists" fi ... (3 Replies)
Discussion started by: Shanmugapriya D
3 Replies

3. Shell Programming and Scripting

How to check more than 1 file specified files exists?

Hi all, One of my script crated created 2 files in a dirs Output.log and Output.tmp. Now in another script i need to check if both of the above mentioned files are present in a directory or not. I know to check one file but need to check both the files. Anyone could please tell me how... (3 Replies)
Discussion started by: girijajoshi
3 Replies

4. Shell Programming and Scripting

Check if file exists or not

Hi, I want to check if the file exists or not in the directory. i am trying below code but not working. File="/home/va59657/Account_20090213*.dat" echo "$File" if ]; then echo "file found" else echo "file not found" fi However i am getting file not found even if file exits as... (5 Replies)
Discussion started by: Vivekit82
5 Replies

5. Shell Programming and Scripting

Check whether file exists in directory

Hi guys, I am beginner trying to learn unix. So any help is welcomed. My requirement is to check whether is a file exists in a particular directory or not. The directory path and filename are taken dynamically with user interaction. So the program should continue only if the $filename... (1 Reply)
Discussion started by: maris_markur
1 Replies

6. Shell Programming and Scripting

How to check if a file exists in a directory?

I want to perform SQL *Loader operation only if a file named "load.txt" exists in a directory "/home/loc/etc". Please help how to check this with a if condition. (8 Replies)
Discussion started by: vel4ever
8 Replies

7. Shell Programming and Scripting

how to check to see if a file exists?

I want to write a script to see if various files exist. What I want to do is have the script search in various directories if a file exist, and if not, then output something like "/path/file does not exist". I don't actually know of how to check and see if a file exists or not. What I have in mind... (2 Replies)
Discussion started by: astropi
2 Replies

8. Shell Programming and Scripting

Script to check file exists

Hi, I am trying to write a script which checks if any file exists with "*.log" or "*.out" in Directory below is the code #------------------ path=/abd/xyz/ if ; then echo "Good" else echo "Failure" fi #-------------------------- its always going to else part and printing... (8 Replies)
Discussion started by: ch33ry
8 Replies

9. Shell Programming and Scripting

Check to see if a file exists?

Hi. I'd like to have an IF-Then-Else statement where I can check to see if a file exists? We have the Bourne Shell by default. I'm looking for the syntax to do something like this: if myfile.txt exists then ...my code else ...my code end if Any help would be greatly... (5 Replies)
Discussion started by: buechler66
5 Replies

10. Programming

Check if file exists + ulp :S

Hi all! I know that this may not be the best forum to ask ulp and eagle related question. But the guys from eagle didn't know the answer and this is the BEST programming forum I know :D How can I check if a file exists while programming eagle's ulp's? There is not much information on-line.... (2 Replies)
Discussion started by: ruben.rodrigues
2 Replies
Login or Register to Ask a Question